// PageCam.cpp : implementation file
//

#include "stdafx.h"
#include "UsbCam.h"
#include "PageCam.h"
#include "Utils.h"
#include "Image.h"
#include "DlgRGBChan.h"
#include "SheetCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageCam property page

IMPLEMENT_DYNCREATE(CPageCam, CPropertyPage)

CPageCam::CPageCam() : CPropertyPage(CPageCam::IDD)
{
	//{{AFX_DATA_INIT(CPageCam)
	m_filename = _T("");
	m_chk_auto_inc = FALSE;
	m_chk_bright = FALSE;
	m_chk_hue = FALSE;
	m_chk_filter = FALSE;
	m_s_cyan = 0;
	m_s_contrast = 0;
	m_s_expo = 0;
	m_s_bright = 0;
	m_s_light = 0;
	m_s_saturation = 0;
	m_s_video = 0;
	m_s_yel = 0;
	m_chk_mirror = FALSE;
	m_chk_flip = FALSE;
	m_edit_filename = _T("");
	m_chk_smart = FALSE;
	//}}AFX_DATA_INIT

	m_pCurImg = new CImage (10,10,3);
}

CPageCam::~CPageCam()
{
	
}

void CPageCam::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageCam)
	DDX_Control(pDX, IDC_SLIDER_YELBLUE, m_slider_yel);
	DDX_Control(pDX, IDC_SLIDER_VIDEO_QUALITY, m_slider_video);
	DDX_Control(pDX, IDC_SLIDER_SATURATION, m_slider_saturation);
	DDX_Control(pDX, IDC_SLIDER_LIGHTSENS, m_slider_light);
	DDX_Control(pDX, IDC_SLIDER_EXPOTIME, m_slider_expo);
	DDX_Control(pDX, IDC_SLIDER_CYANRED, m_slider_cyan);
	DDX_Control(pDX, IDC_SLIDER_CONTRAST, m_slider_contrast);
	DDX_Control(pDX, IDC_SLIDER_BRIGHTNESS, m_slider_bright);
	DDX_Control(pDX, IDC_BUTTON_ENABLE_VIDEO, m_but_enable);
	DDX_Control(pDX, IDC_QCVIDEOXCTRL, m_VideoFrame);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Check(pDX, IDC_CHECK_AUTO_INC, m_chk_auto_inc);
	DDX_Check(pDX, IDC_CHECK_AUTO_BRIGHTNESS, m_chk_bright);
	DDX_Check(pDX, IDC_CHECK_AUTO_HUE, m_chk_hue);
	DDX_Check(pDX, IDC_CHECK_LOW_LIGHT, m_chk_filter);
	DDX_Text(pDX, IDC_EDIT_CIAND_RED, m_s_cyan);
	DDV_MinMaxInt(pDX, m_s_cyan, 0, 255);
	DDX_Text(pDX, IDC_EDIT_CONTRAST, m_s_contrast);
	DDV_MinMaxInt(pDX, m_s_contrast, 0, 255);
	DDX_Text(pDX, IDC_EDIT_EXPO_TIME, m_s_expo);
	DDV_MinMaxInt(pDX, m_s_expo, 0, 255);
	DDX_Text(pDX, IDC_EDIT_BRIGHTNESS, m_s_bright);
	DDV_MinMaxInt(pDX, m_s_bright, 0, 255);
	DDX_Text(pDX, IDC_EDIT_LIGHT_SENS, m_s_light);
	DDV_MinMaxInt(pDX, m_s_light, 0, 255);
	DDX_Text(pDX, IDC_EDIT_SATURATION, m_s_saturation);
	DDV_MinMaxInt(pDX, m_s_saturation, 0, 255);
	DDX_Text(pDX, IDC_EDIT_VIDEO_QUAL, m_s_video);
	DDV_MinMaxInt(pDX, m_s_video, 0, 4);
	DDX_Text(pDX, IDC_EDIT_YEL_BLUE, m_s_yel);
	DDV_MinMaxInt(pDX, m_s_yel, 0, 255);
	DDX_Check(pDX, IDC_CHECK_MIRROR, m_chk_mirror);
	DDX_Check(pDX, IDC_CHECK_FLIP, m_chk_flip);
	DDX_Text(pDX, IDC_STATIC_FILENAME, m_edit_filename);
	DDX_Check(pDX, IDC_CHECK_PICTURE_SMART, m_chk_smart);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageCam, CPropertyPage)
	//{{AFX_MSG_MAP(CPageCam)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_VIDEO, OnButtonEnableVideo)
	ON_BN_CLICKED(IDC_BUTTON_DIM, OnButtonDim)
	ON_BN_CLICKED(IDC_BUTTON_TAKE_PICTURE, OnButtonTakePicture)
	ON_BN_CLICKED(IDC_CHECK_AUTO_INC, OnCheckAutoInc)
	ON_BN_CLICKED(IDC_BUTTON_SETTINGS, OnButtonSettings)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_AUTO_HUE, OnCheckAutoHue)
	ON_EN_CHANGE(IDC_EDIT_CIAND_RED, OnChangeEditCiandRed)
	ON_EN_CHANGE(IDC_EDIT_YEL_BLUE, OnChangeEditYelBlue)
	ON_EN_CHANGE(IDC_EDIT_CONTRAST, OnChangeEditContrast)
	ON_EN_CHANGE(IDC_EDIT_EXPO_TIME, OnChangeEditExpoTime)
	ON_EN_CHANGE(IDC_EDIT_FILENAME, OnChangeEditFilename)
	ON_EN_CHANGE(IDC_EDIT_LIGHT_SENS, OnChangeEditLightSens)
	ON_EN_CHANGE(IDC_EDIT_SATURATION, OnChangeEditSaturation)
	ON_EN_CHANGE(IDC_EDIT_VIDEO_QUAL, OnChangeEditVideoQual)
	ON_EN_CHANGE(IDC_EDIT_BRIGHTNESS, OnChangeEditBrightness)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnButtonDefault)
	ON_BN_CLICKED(IDC_CHECK_AUTO_BRIGHTNESS, OnCheckAutoBrightness)
	ON_BN_CLICKED(IDC_CHECK_LOW_LIGHT, OnCheckLowLight)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_MIRROR, OnCheckMirror)
	ON_BN_CLICKED(IDC_CHECK_FLIP, OnCheckFlip)
	ON_BN_CLICKED(IDC_BUTTON_DISPLAY_PICTURE, OnButtonDisplayPicture)
	ON_BN_CLICKED(IDC_BUTTON_DISPLAY_CHANNELS, OnButtonDisplayChannels)
	ON_BN_CLICKED(IDC_CHECK_PICTURE_SMART, OnCheckPictureSmart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageCam message handlers

BOOL CPageCam::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_pict_count = 0;

	// Initialization of m_dc
	m_dc = new CClientDC(this);
	
	// Restore defaults
	Read_Registry();

	// Assign pointers on sliders
	pslider_cyan	= GetDlgItem(IDC_SLIDER_CYANRED);
	pslider_yel		= GetDlgItem(IDC_SLIDER_YELBLUE);
	pslider_saturation = GetDlgItem(IDC_SLIDER_SATURATION);
	pslider_bright  = GetDlgItem(IDC_SLIDER_BRIGHTNESS);
	pslider_contrast = GetDlgItem(IDC_SLIDER_CONTRAST);
	pslider_expo	= GetDlgItem(IDC_SLIDER_EXPOTIME);
	pslider_light	= GetDlgItem(IDC_SLIDER_LIGHTSENS);
	pslider_video	= GetDlgItem(IDC_SLIDER_VIDEO_QUALITY);
	
	// Write default values
	m_VideoFrame.UnInitialization();
	if (m_VideoFrame.Initialization (0)) m_bInit = TRUE;
	else m_bInit = FALSE;
	Sleep (200);

	m_VideoFrame.SetColorMode	   ((short) m_chk_hue);
	if (m_chk_hue)
	{
		if (!SetTimer (TIMER_HUE,INTERVAL,NULL)) AfxMessageBox (COULD_NOT_START_UP_TIMER);
	}
	m_VideoFrame.SetBrightnessMode ((short) m_chk_bright);
	if (m_chk_bright)
	{
		if (!SetTimer (TIMER_BRIGHT,INTERVAL,NULL)) AfxMessageBox (COULD_NOT_START_UP_TIMER);
	}
	if ((m_chk_mirror)  && (!m_chk_flip)) m_VideoFrame.SetOrientation (1);
	if ((m_chk_mirror)  && (m_chk_flip))  m_VideoFrame.SetOrientation (3);
	if ((!m_chk_mirror) && (!m_chk_flip)) m_VideoFrame.SetOrientation (0);
	if ((!m_chk_mirror) && (m_chk_flip))  m_VideoFrame.SetOrientation (2);
	
	m_VideoFrame.SetLowLightFilter (m_chk_filter);
	m_VideoFrame.SetCyanRedColor   (m_s_cyan);
	m_VideoFrame.SetYellowBlueColor (m_s_yel);
	m_VideoFrame.SetSaturation  (m_s_saturation);
	m_VideoFrame.SetBrightnessMagnitude (m_s_bright);
	m_VideoFrame.SetContrastMagnitude (m_s_contrast);

	m_VideoFrame.SetExposure (m_s_expo);
	m_VideoFrame.SetCompression (m_s_video);
	m_VideoFrame.SetGain (m_s_light);

	// Init the sliders
	m_slider_bright.SetRangeMin (0,FALSE);
	m_slider_bright.SetRangeMax (255,TRUE);
	m_slider_bright.SetTicFreq(20);

	m_slider_contrast.SetRangeMin (0,FALSE);
	m_slider_contrast.SetRangeMax (255,TRUE);
	m_slider_contrast.SetTicFreq(20);

	m_slider_cyan.SetRangeMin (0,FALSE);
	m_slider_cyan.SetRangeMax (255,TRUE);
	m_slider_cyan.SetTicFreq(20);

	m_slider_expo.SetRangeMin (0,FALSE);
	m_slider_expo.SetRangeMax (255,TRUE);
	m_slider_expo.SetTicFreq(20);

	m_slider_light.SetRangeMin (0,FALSE);
	m_slider_light.SetRangeMax (255,TRUE);
	m_slider_light.SetTicFreq(20);

	m_slider_saturation.SetRangeMin (0,FALSE);
	m_slider_saturation.SetRangeMax (255,TRUE);
	m_slider_saturation.SetTicFreq(20);

	m_slider_video.SetRangeMin (0,FALSE);
	m_slider_video.SetRangeMax (4,TRUE);
	m_slider_video.SetPos (m_s_video);
	m_slider_video.SetTicFreq(1);

	m_slider_yel.SetRangeMin (0,FALSE);
	m_slider_yel.SetRangeMax (255,TRUE);
	m_slider_yel.SetTicFreq(20);

	// Update groups and fields
	UpdateAll();
	m_filename = "Picture";
	m_filename.Format ("%s%i", m_filename, m_pict_count);
	UpdateData (FALSE);

	// Enable or disable video
	m_bLive = !m_bLive;
	CPageCam::OnButtonEnableVideo();

	UpdateData (FALSE);
	
	return TRUE;  
}

void CPageCam::OnDestroy() 
{
	CPropertyPage::OnDestroy();
	
	m_VideoFrame.UnInitialization();
	Store_Registry();
}

BOOL CPageCam::PreTranslateMessage(MSG* pMsg) 
{
	if ((pMsg->message == WM_LBUTTONUP) || (pMsg->message == WM_MOUSEMOVE))
	{
		CWnd* pfocus = GetFocus();
		
		if (pslider_cyan == pfocus)
		{
			m_s_cyan = m_slider_cyan.GetPos();
			m_VideoFrame.SetCyanRedColor (m_s_cyan);
			UpdateData (FALSE);
		}
		else
		if (pslider_yel == pfocus)
		{
			m_s_yel = m_slider_yel.GetPos();
			m_VideoFrame.SetYellowBlueColor (m_s_yel);
			UpdateData (FALSE);
		}
		else
		if (pslider_saturation == pfocus)
		{
			m_s_saturation = m_slider_saturation.GetPos();
			m_VideoFrame.SetSaturation (m_s_saturation);
			UpdateData (FALSE);
		}
		else
		if (pslider_bright == pfocus)
		{
			m_s_bright = m_slider_bright.GetPos();
			m_VideoFrame.SetBrightnessMagnitude (m_s_bright);
			UpdateData (FALSE);
		}
		else
		if (pslider_contrast == pfocus)
		{
			m_s_contrast = m_slider_contrast.GetPos();
			m_VideoFrame.SetContrastMagnitude (m_s_contrast);
			UpdateData (FALSE);
		}
		else
		if (pslider_expo == pfocus)
		{
			m_s_expo = m_slider_expo.GetPos();
			m_VideoFrame.SetExposure (m_s_expo);
			UpdateData (FALSE);
		}
		else
		if (pslider_light == pfocus)
		{
			m_s_light = m_slider_light.GetPos();
			m_VideoFrame.SetGain (m_s_light);
			UpdateData (FALSE);
		}
		else
		if (pslider_video == pfocus)
		{
			m_s_video = m_slider_video.GetPos();
			m_VideoFrame.SetCompression (m_s_video);
			UpdateData (FALSE);
		}
	}

	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CPageCam::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{
		case TIMER_HUE :
			UpdateHueGroup();
			break;

		case TIMER_BRIGHT :
			UpdateBrightGroup();
			break;

		default : break;
	}
	CPropertyPage::OnTimer(nIDEvent);
}

//*****************************************
//*  Update procedures					  *
//*****************************************
void CPageCam::UpdateHueGroup()
{
	short tmp;
	
	UpdateData (TRUE);
	m_VideoFrame.GetCyanRedColor (&m_s_cyan);
	m_slider_cyan.SetPos (m_s_cyan);
	m_VideoFrame.GetYellowBlueColor (&m_s_yel);
	m_slider_yel.SetPos (m_s_yel);
	m_VideoFrame.GetSaturation (&m_s_saturation);
	m_slider_saturation.SetPos (m_s_saturation);

	m_VideoFrame.GetColorMode (&tmp);
	if (m_chk_hue = BOOL (tmp))
	{
		GetDlgItem(IDC_SLIDER_CYANRED)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLIDER_YELBLUE)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_CIAND_RED)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_YEL_BLUE)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SLIDER_CYANRED)->EnableWindow(TRUE);
		GetDlgItem(IDC_SLIDER_YELBLUE)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_CIAND_RED)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_YEL_BLUE)->EnableWindow(TRUE);
	}

	UpdateData (FALSE);
}


void CPageCam::UpdateBrightGroup()
{
	short tmp;
	
	UpdateData (TRUE);
	m_VideoFrame.GetBrightnessMagnitude (&m_s_bright);
	m_slider_bright.SetPos (m_s_bright);
	m_VideoFrame.GetContrastMagnitude (&m_s_contrast);
	m_slider_contrast.SetPos (m_s_contrast);
	m_VideoFrame.GetExposure(&m_s_expo);
	m_slider_expo.SetPos (m_s_expo);
	m_VideoFrame.GetGain (&m_s_light);
	m_slider_light.SetPos (m_s_light);

	m_VideoFrame.GetBrightnessMode (&tmp);
	if (m_chk_bright = BOOL (tmp))
	{
		GetDlgItem(IDC_SLIDER_BRIGHTNESS)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLIDER_EXPOTIME)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_BRIGHTNESS)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_EXPO_TIME)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_LIGHT_SENS)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLIDER_LIGHTSENS)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SLIDER_BRIGHTNESS)->EnableWindow(TRUE);
		GetDlgItem(IDC_SLIDER_EXPOTIME)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_BRIGHTNESS)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_EXPO_TIME)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_LIGHT_SENS)->EnableWindow(TRUE);
		GetDlgItem(IDC_SLIDER_LIGHTSENS)->EnableWindow(TRUE);
	}

	UpdateData (FALSE);
}

void CPageCam::UpdateAll()
{
	UpdateHueGroup();
	UpdateBrightGroup();
	m_chk_filter = m_VideoFrame.GetLowLightFilter ();
	UpdateData (FALSE);
}

//*****************************************
//*  Check buttons functions			  *
//*****************************************
void CPageCam::OnCheckAutoHue() 
{
	m_chk_hue = !m_chk_hue;
	UpdateData (FALSE);
	if (m_chk_hue) 
	{
		m_VideoFrame.SetColorMode (1);
		if (!SetTimer (TIMER_HUE,INTERVAL,NULL)) AfxMessageBox (COULD_NOT_START_UP_TIMER);	
	}
	else 
	{
		m_VideoFrame.SetColorMode (0);
		KillTimer(TIMER_HUE);
	}
	UpdateHueGroup();	
}

void CPageCam::OnCheckAutoBrightness() 
{
	m_chk_bright = !m_chk_bright;
	UpdateData (FALSE);
	if (m_chk_bright) 
	{
		m_VideoFrame.SetBrightnessMode (1);
		if (!SetTimer (TIMER_BRIGHT,INTERVAL,NULL)) AfxMessageBox (COULD_NOT_START_UP_TIMER);
	}
	else 
	{
		m_VideoFrame.SetBrightnessMode (0);
		KillTimer(TIMER_BRIGHT);
	}
	UpdateBrightGroup();
}

void CPageCam::OnCheckLowLight() 
{
	m_chk_filter = !m_chk_filter;
	UpdateData (FALSE);
	if (m_chk_filter) m_VideoFrame.SetLowLightFilter (TRUE);
	else m_VideoFrame.SetLowLightFilter (FALSE);
}

void CPageCam::OnCheckPictureSmart() 
{
	m_chk_smart = !m_chk_smart;
	UpdateData (FALSE);
	if (m_chk_smart) m_VideoFrame.EnablePictureSmart (TRUE);
	else m_VideoFrame.EnablePictureSmart (FALSE);	
}

void CPageCam::OnCheckMirror() 
{
	m_chk_mirror = !m_chk_mirror;
	UpdateData (FALSE);
	if ((m_chk_mirror)  && (!m_chk_flip)) m_VideoFrame.SetOrientation (1);
	if ((m_chk_mirror)  && (m_chk_flip))  m_VideoFrame.SetOrientation (3);
	if ((!m_chk_mirror) && (!m_chk_flip)) m_VideoFrame.SetOrientation (0);
	if ((!m_chk_mirror) && (m_chk_flip))  m_VideoFrame.SetOrientation (2);
}

void CPageCam::OnCheckFlip() 
{
	m_chk_flip = !m_chk_flip;
	UpdateData (FALSE);
	if ((m_chk_mirror)  && (!m_chk_flip)) m_VideoFrame.SetOrientation (1);
	if ((m_chk_mirror)  && (m_chk_flip))  m_VideoFrame.SetOrientation (3);
	if ((!m_chk_mirror) && (!m_chk_flip)) m_VideoFrame.SetOrientation (0);
	if ((!m_chk_mirror) && (m_chk_flip))  m_VideoFrame.SetOrientation (2);
}

void CPageCam::OnCheckAutoInc() 
{
	UpdateData (TRUE);	
}

//*****************************************
//*  Buttons procedures					  *
//*****************************************

void CPageCam::OnButtonDisplayPicture() 
{
	m_pCurImg->DisplayImage (m_dc->m_hDC,197,20,320,240,0, ALL_IMAGE, SRCCOPY);
}

void CPageCam::OnButtonDisplayChannels() 
{
	CDlgRGBChan dlg(NULL,m_pCurImg);
	dlg.DoModal();
}

void CPageCam::OnButtonSettings() 
{
	m_VideoFrame.DlgVideoSource();
	UpdateAll();
}

void CPageCam::OnButtonDim() 
{
	m_VideoFrame.DlgVideoFormat();	 
}

void CPageCam::OnButtonDefault() 
{
	m_VideoFrame.RestoreDriverDefaults();
	Sleep (200);
	UpdateAll();
}

void CPageCam::OnButtonTakePicture() 
{
	UpdateData (TRUE);
	if (m_filename == "") return;
	m_filename.Format ("%s%s", m_filename, STRING_BMP_EXT);


	if ( !m_VideoFrame.SaveSingleFrameToFile (m_filename) )
	{
		AfxMessageBox ("Could not save file");
		return;
	}

	delete m_pCurImg;
	m_pCurImg = new CImage();
	m_pCurImg->ReadFromFile (m_filename);
	m_pCurImg->DisplayImage (m_dc->m_hDC,197,20,320,240,120, ALL_IMAGE, SRCCOPY);
	m_edit_filename = m_filename;

	m_filename = "Picture";
	if (m_chk_auto_inc) m_pict_count++;
	m_filename.Format ("%s%i", m_filename, m_pict_count);
	UpdateData (FALSE);
	CPageCam::OnPaint();
}

void CPageCam::OnButtonEnableVideo() 
{
	CString str;
	
	if (m_bLive == TRUE)
	{
		if (m_bInit == FALSE) 
		{
			if (m_VideoFrame.Initialization (0)) m_bInit = TRUE;
			else return;
		}
		m_VideoFrame.SetVideoDisplay(FALSE);
		m_bLive = FALSE;
		str = "Enable Video";
		m_but_enable.SetWindowText (str);
	}
	else
	{
		if (m_bInit == FALSE) 
		{
			if (m_VideoFrame.Initialization (0)) m_bInit = TRUE;
			else return;
		}
		m_VideoFrame.SetVideoDisplay(TRUE);
		m_bLive = TRUE;
		str = "Disable Video";
		m_but_enable.SetWindowText (str);
		CPageCam::UpdateAll();
	}
}

//*****************************************
//*  OnChangeEdit functions				  *
//*****************************************

void CPageCam::OnChangeEditCiandRed() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_CIAND_RED)->GetWindowText(str);
	if (str == "") return;
	
	UpdateData (TRUE);
	if (m_s_cyan <= 255) 
	{
		m_VideoFrame.SetCyanRedColor (m_s_cyan);
		UpdateHueGroup();
	}
}

void CPageCam::OnChangeEditYelBlue() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_YEL_BLUE)->GetWindowText(str);
	if (str == "") return;
	
	UpdateData (TRUE);	
	if (m_s_yel <= 255) 
	{
		m_VideoFrame.SetYellowBlueColor (m_s_yel);
		UpdateHueGroup();
	}
}

void CPageCam::OnChangeEditContrast() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_CONTRAST)->GetWindowText(str);
	if (str == "") return;	
	
	UpdateData (TRUE);
	if (m_s_contrast <= 255) 
	{
		m_VideoFrame.SetContrastMagnitude (m_s_contrast);
		UpdateBrightGroup();
	}
}

void CPageCam::OnChangeEditExpoTime() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_EXPO_TIME)->GetWindowText(str);
	if (str == "") return;

	UpdateData (TRUE);
	if (m_s_expo <= 255) 
	{
		m_VideoFrame.SetExposure (m_s_expo);
		UpdateBrightGroup();
	}
}

void CPageCam::OnChangeEditLightSens() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_LIGHT_SENS)->GetWindowText(str);
	if (str == "") return;

	UpdateData (TRUE);
	if (m_s_light <= 255) 
	{
		m_VideoFrame.SetGain(m_s_light);
		UpdateBrightGroup();
	}
}

void CPageCam::OnChangeEditSaturation() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_SATURATION)->GetWindowText(str);
	if (str == "") return;
	
	UpdateData (TRUE);
	if (m_s_saturation <= 255) 
	{
		m_VideoFrame.SetSaturation (m_s_saturation);
		UpdateHueGroup();
	}
}

void CPageCam::OnChangeEditBrightness() 
{	
	CString str;
	
	GetDlgItem (IDC_EDIT_BRIGHTNESS)->GetWindowText(str);
	if (str == "") return;

	UpdateData (TRUE);
	if (m_s_bright <= 255) 
	{
		m_VideoFrame.SetBrightnessMagnitude (m_s_bright);
		UpdateBrightGroup();
	}
}

void CPageCam::OnChangeEditVideoQual() 
{
	CString str;
	
	GetDlgItem (IDC_EDIT_VIDEO_QUAL)->GetWindowText(str);
	if (str == "") return;
	
	UpdateData (TRUE);
	if (m_s_video <= 4) 
	{
		m_VideoFrame.SetCompression (m_s_video);
		m_slider_video.SetPos (m_s_video);
	}
}

void CPageCam::OnChangeEditFilename() 
{
	UpdateData (TRUE);
}

//*****************************************
//*  Registry procedures				  *
//*****************************************
void CPageCam::Read_Registry()
{
	CWinApp* pApp = AfxGetApp();

	// The check
	m_chk_auto_inc  = (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_AUTO_INC,FALSE);
	m_chk_bright    = (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_AUTO_BRIGHT,TRUE);
	m_chk_hue	    = (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_AUTO_HUE,TRUE);
	m_chk_filter    = (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_LIGHT_FILTER,TRUE);
	m_chk_mirror    = (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_MIRROR,FALSE);
	m_chk_flip      = (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_FLIP,FALSE);

	// The edit fields
	m_s_cyan		= pApp->GetProfileInt	 (SECTION_CAM,ITEM_CYANRED,128);
	m_s_yel			= pApp->GetProfileInt	 (SECTION_CAM,ITEM_YELLOWBLUE,128);
	m_s_saturation	= pApp->GetProfileInt	 (SECTION_CAM,ITEM_SATURATION,128);
	m_s_bright		= pApp->GetProfileInt	 (SECTION_CAM,ITEM_BRIGHTNESS,128);
	m_s_contrast	= pApp->GetProfileInt	 (SECTION_CAM,ITEM_CONTRAST,128);
	m_s_expo		= pApp->GetProfileInt	 (SECTION_CAM,ITEM_EXPO,128);
	m_s_light		= pApp->GetProfileInt	 (SECTION_CAM,ITEM_LIGHT_SENS,128);
	m_s_video		= pApp->GetProfileInt	 (SECTION_CAM,ITEM_VIDEO,4);

	m_bLive			= (BOOL) pApp->GetProfileInt	 (SECTION_CAM,ITEM_LIVE,FALSE);

    UpdateData (FALSE);
}

void CPageCam::Store_Registry()
{
	CWinApp* pApp = AfxGetApp();

	// The check
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_AUTO_INC, m_chk_auto_inc);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_AUTO_BRIGHT,m_chk_bright );
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_AUTO_HUE,m_chk_hue);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_LIGHT_FILTER,m_chk_filter);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_MIRROR,m_chk_mirror);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_FLIP,m_chk_flip);

	pApp->WriteProfileInt	(SECTION_CAM, ITEM_CYANRED,m_s_cyan);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_YELLOWBLUE,m_s_yel	);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_SATURATION,m_s_saturation);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_BRIGHTNESS,m_s_bright);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_CONTRAST,m_s_contrast);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_EXPO,m_s_expo);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_LIGHT_SENS,m_s_light);
	pApp->WriteProfileInt	(SECTION_CAM, ITEM_VIDEO,m_s_video);

	pApp->WriteProfileInt	(SECTION_CAM, ITEM_LIVE, (int) m_bLive);
}

//*****************************************
//*  Other procedures					  *
//*****************************************

BOOL CPageCam::OnSetActive() 
{
	return CPropertyPage::OnSetActive();
}
