//{{AFX_INCLUDES()
#include "qcvideox.h"
//}}AFX_INCLUDES
#if !defined(AFX_PAGECAM_H__09F5DB01_922C_11D3_95F1_00600895DAA5__INCLUDED_)
#define AFX_PAGECAM_H__09F5DB01_922C_11D3_95F1_00600895DAA5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PageCam.h : header file
//
#include "Image.h"
//#include "PageImg.h"

#define SECTION_CAM		  "Camera Settings"
#define ITEM_AUTO_INC	  "Auto incrementation"
#define ITEM_AUTO_HUE	  "Auto hue"
#define ITEM_AUTO_BRIGHT  "Auto brightness"
#define ITEM_LIGHT_FILTER "Low Light Filter"
#define ITEM_CONTRAST	  "Contrast"
#define ITEM_CYANRED      "Cyan-Red"
#define ITEM_YELLOWBLUE   "Yellow-Blue"
#define ITEM_EXPO	      "Exposure Time"
#define ITEM_LIGHT_SENS   "Light Sens"
#define ITEM_SATURATION   "Saturation"
#define ITEM_VIDEO	      "Video"
#define ITEM_BRIGHTNESS   "Brightness"
#define ITEM_VIDEO		  "Video"
#define ITEM_LIVE		  "Live On"
#define ITEM_MIRROR		  "Mirror"
#define ITEM_FLIP		  "Flip"

// Define timers
#define TIMER_HUE		  0
#define TIMER_BRIGHT	  1
#define INTERVAL		  400
#define COULD_NOT_START_UP_TIMER "Could not start up timer !"


/////////////////////////////////////////////////////////////////////////////
// CPageCam dialog

class CPageCam : public CPropertyPage
{
	DECLARE_DYNCREATE(CPageCam)

// Construction
public:
	CPageCam();
	~CPageCam();

// Dialog Data
	//{{AFX_DATA(CPageCam)
	enum { IDD = IDD_PAGE_QUICKCAM };
	CSliderCtrl	m_slider_yel;
	CSliderCtrl	m_slider_video;
	CSliderCtrl	m_slider_saturation;
	CSliderCtrl	m_slider_light;
	CSliderCtrl	m_slider_expo;
	CSliderCtrl	m_slider_cyan;
	CSliderCtrl	m_slider_contrast;
	CSliderCtrl	m_slider_bright;
	CButton	m_but_enable;
	CQCVideoX	m_VideoFrame;
	CString	m_filename;
	BOOL	m_chk_auto_inc;
	BOOL	m_chk_bright;
	BOOL	m_chk_hue;
	BOOL	m_chk_filter;
	short	m_s_cyan;
	short	m_s_contrast;
	short	m_s_expo;
	short	m_s_bright;
	short	m_s_light;
	short	m_s_saturation;
	short	m_s_video;
	short	m_s_yel;
	BOOL	m_chk_mirror;
	BOOL	m_chk_flip;
	CString	m_edit_filename;
	BOOL	m_chk_smart;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPageCam)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPageCam)
	afx_msg void OnButtonEnableVideo();
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonDim();
	afx_msg void OnButtonTakePicture();
	afx_msg void OnCheckAutoInc();
	afx_msg void OnButtonSettings();
	afx_msg void OnDestroy();
	afx_msg void OnCheckAutoHue();
	afx_msg void OnChangeEditCiandRed();
	afx_msg void OnChangeEditYelBlue();
	afx_msg void OnChangeEditContrast();
	afx_msg void OnChangeEditExpoTime();
	afx_msg void OnChangeEditFilename();
	afx_msg void OnChangeEditLightSens();
	afx_msg void OnChangeEditSaturation();
	afx_msg void OnChangeEditVideoQual();
	afx_msg void OnChangeEditBrightness();
	afx_msg void OnButtonDefault();
	afx_msg void OnCheckAutoBrightness();
	afx_msg void OnCheckLowLight();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCheckMirror();
	afx_msg void OnCheckFlip();
	afx_msg void OnButtonDisplayPicture();
	afx_msg void OnButtonDisplayChannels();
	afx_msg void OnCheckPictureSmart();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void UpdateBrightGroup();
	void UpdateAll ();
	void Store_Registry();
	void Read_Registry();
	void UpdateHueGroup();
	BOOL	m_bLive;
	BOOL	m_bInit;
	int		m_pict_count;
	CClientDC*  m_dc;
	CImage* m_pCurImg;
	CWnd*  pslider_cyan;
	CWnd*  pslider_yel;
	CWnd*  pslider_saturation;
	CWnd*  pslider_bright;
	CWnd*  pslider_contrast;
	CWnd*  pslider_expo;
	CWnd*  pslider_light;
	CWnd*  pslider_video;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGECAM_H__09F5DB01_922C_11D3_95F1_00600895DAA5__INCLUDED_)
